


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% MODIFIABLE
% latitude initiale (en degre)
lat0=45;


% parametre de forme de la vorticite relative
a=1;

% vitesse max du vent zonal
U0=0;
% 10

% nombre de pas de temps  (en jours)
duree=3;



% amplitude du geopotentiel
amplitude=600;


% taille de la perturbation
taille=2000e3;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





% pas de temps
dt=3600;

nt=duree*3600*24/dt;

% parametres de Coriolis
f0=4*pi/24/3600*sin(lat0*pi/180);
beta=4*pi/24/3600/6370e3*cos(lat0*pi/180);

% intervalle d'enregistrement
nstep=1;

% nombre total de sauvegardes
ntotal=nt/nstep;
time(1:ntotal)=0;
temps=0;

%  resolution spatiale
%kmax=255;
kmax=127;
nkx = 2*kmax+1;  nky = kmax+1;
nx = 2*(kmax+1); ny = nx;

% taille du domaine
Lx=50000e3;
Ly=20000e3;


% domaine
x=(0:nx-1)*Lx/nx; y=(0:ny-1)*Ly/ny;
x=x-Lx/2; y=y-Ly/2;
[X,Y]=meshgrid(x,y); X=X';Y=Y';


Ug=U0;%./cosh(Y/1000e3).^2;

% domaine pr interpolation trajectoires
xp=(-1:nx)*Lx/nx; yp=(-1:ny)*Ly/ny;
xp=xp-Lx/2; yp=yp-Ly/2;
[Xp,Yp]=meshgrid(xp,yp); Xp=Xp';Yp=Yp';

% vecteur d'onde
[kx_,ky_] = ndgrid(-kmax:kmax,0:kmax);
kx_=kx_*2*pi/Lx; ky_=ky_*2*pi/Ly;

% calcul du filtre exponentiel pour supprimer les petites echelles
k0_=sqrt(kx_.^2+ky_.^2);
filter=k0_*0+1;
kcut=2*pi/Lx*10;
idx=find(k0_>kcut);
filtdec=-log(1+40*pi/nx)/(kmax*2*pi/Lx-kcut)^6;
filter(idx)=exp(filtdec*(k0_(idx)-kcut).^6);
idx=find(k0_>2*pi/Lx*kmax*sqrt(8/9));
filter(idx)=0;

F_bord=1-(1-(abs(Y/y(end)).^8)).^8;

vortg=zeros(nx,ny,ntotal);


% condition initiale
%phig2=(-10*tanh((Y+4e5*cos((X-Lx/2)*1*pi/5e6))/1e6))*200;
%phig=-amplitude*cos(2*pi*X/Lx).*exp(-a*Y.^2/1300e3^2);
%phig=-amplitude*(-exp(-((X+5e6).^2+a*Y.^2)/2500e3^2)+exp(-((X-5e6).^2+a*Y.^2)/2500e3^2));

vortg(:,:,1)=amplitude/f0/taille^2*exp(-(X.^2+a*Y.^2)/taille^2);
vortg(:,:,1)=spec2grid_v2(filter.*grid2spec_v2(vortg(:,:,1)));
votmp=grid2spec_v2(vortg(:,:,1));

%phig=-amplitude*exp(-(X.^2+a*Y.^2)/2000e3^2);
%phi=filter.*grid2spec_v2(phig);
%votmp=-phi.*(kx_.^2+ky_.^2)/f0;
%vortg(:,:,1)=spec2grid_v2(votmp);

corio=f0+beta*Y;

%xt=[x(1)/4 x(nx/2) x(end)/4];
%yt=[0 0 0];

%ntraj=length(xt);
%xtraj=zeros(ntraj,ntotal);
%ytraj=xtraj;
%xtraj(:,1)=xt;
%ytraj(:,1)=yt;

isauv=1;

for it=2:nt

  temps=temps+dt;
  
  % runge-kutta d'ordre 4 en temps
  tvo1=tendance_rossby1(votmp,kx_,ky_,beta,Ug);
%  [tx1,ty1]=tendancetraj(xt,yt,votmp,kx_,ky_,Xp,Yp);

%  xt1=xt+tx1*dt/2;  yt1=yt+ty1*dt/2;
%  xt1=mod(xt1+Lx/2,Lx)-Lx/2;   yt1=mod(yt1+Ly/2,Ly)-Ly/2; 
  tvo2=tendance_rossby1(votmp+tvo1*dt/2,kx_,ky_,beta,Ug);
%  [tx2,ty2]=tendancetraj(xt1,yt1,votmp+tvo1*dt/2,kx_,ky_,Xp,Yp);
  
  
%  xt2=xt+tx2*dt/2;  yt2=yt+ty2*dt/2;
%  xt2=mod(xt2+Lx/2,Lx)-Lx/2;   yt2=mod(yt2+Ly/2,Ly)-Ly/2;
  tvo3=tendance_rossby1(votmp+tvo2*dt/2,kx_,ky_,beta,Ug);
%  [tx3,ty3]=tendancetraj(xt2,yt2,votmp+tvo2*dt/2,kx_,ky_,Xp,Yp);
    
%  xt3=xt+tx3*dt;  yt3=yt+ty3*dt;
%  xt3=mod(xt3+Lx/2,Lx)-Lx/2;   yt3=mod(yt3+Ly/2,Ly)-Ly/2;   
  tvo4=tendance_rossby1(votmp+tvo3*dt,kx_,ky_,beta,Ug);
%  [tx4,ty4]=tendancetraj(xt3,yt3,votmp+tvo3*dt,kx_,ky_,Xp,Yp);
  
  votmp=filter.*(votmp+dt*(tvo1+tvo2*2+tvo3*2+tvo4)/6 -...
               dt*grid2spec_v2(spec2grid_v2(votmp).*F_bord/3600));
  
%  xt=xt+dt*(tx1+tx2*2+tx3*2+tx4)/6;
%  yt=yt+dt*(ty1+ty2*2+ty3*2+ty4)/6;
%  xt=mod(xt+Lx/2,Lx)-Lx/2;   yt=mod(yt+Ly/2,Ly)-Ly/2;   
  
  if(mod(it,nstep)==0)
    isauv=isauv+1
    time(isauv)=temps;
    vortg(:,:,isauv)=spec2grid_v2(votmp);
 %   xtraj(:,isauv)=squeeze(xt);
 %   ytraj(:,isauv)=squeeze(yt);
  end  
end


%pcolor(x*1e-3,time/3600,squeeze(vortg(:,nx/2,:))')
%contourf(x*1e-6,y*1e-6,vortg(:,:,50)'*10+corio')

%toto=grid2spec_v2(vortg(:,:,10));
%ug=spec2grid_v2(-i*toto.*ky_./(kx_.^2+ky_.^2+eps));